function f = f(x,ElemFlag,t,varargin)
% F Right hand side source term.
%
%   F = F(X,ELEMFLAG,T) computes the value of the right hand side source
%   term at the points X for the the time T.
%
%   Example:
%
%   f = f(x,-1,0);

%   Copyright 2006-2006 Patrick Meury
%   SAM - Seminar for Applied Mathematics
%   ETH-Zentrum
%   CH-8092 Zurich, Switzerland

  f = cos(2*pi*x(:,1)).*(pi^2*sin(t*pi*x(:,2))*(t^2 + 4) + ...
      pi*cos(t*pi*x(:,2)).*x(:,2));
  
return