clear all
close all
  
% Initialize constants
NREFS = 6;              % Number of unifrom red refinements
T = 0.5;                % Final time
G_HANDLE = @g;          % Dirichlet boundary data
F_HANDLE = @f;          % Right hand side source term        
U0_HANDLE = @u0;        % Initial data
UEX_HANDLE = @uex;      % Exact solution
  
% Initialize mesh
Mesh = load_Mesh('Coord_Sqr.dat','Elem_Sqr.dat'); 
Mesh = add_Edges(Mesh);
Loc = get_BdEdges(Mesh);
Mesh.BdFlags = zeros(size(Mesh.Edges,1),1);
Mesh.BdFlags(Loc) = -1;
Mesh.ElemFlag = zeros(size(Mesh.Elements,1),1);  
    
% Do NREFS uniform refinement steps
L2Err = zeros(1,NREFS);
nDofs = zeros(1,NREFS);
for j = 1:NREFS
      
    % refine mesh
    Mesh = refine_REG(Mesh);
      
    % Compute matrices
    M = % YOUR CODE HERE
    A = % YOUR CODE HERE
      
    % number of time steps
    NSTEPS = ceil(sqrt(size(Mesh.Coordinates,1))*T); 
      
    % Compute time step
    dt = T/NSTEPS;
      
    % Compute initial data

    %%%%%%%%%%%%%%%%%%
    % YOUR CODE HERE %
    %%%%%%%%%%%%%%%%%%
      
    % Start timestepping
    for i = 1:(NSTEPS)      

        %%%%%%%%%%%%%%%%%%
        % YOUR CODE HERE %
        %%%%%%%%%%%%%%%%%%
      
    end
      
    % Compute L2 error    
    L2Err(j) = % YOUR CODE HERE
    nDofs(j) = % YOUR CODE HERE
end
  
% Plot out discretization error against number of dofs and add slope
% triangles
figure(1)
h = axes;
plot(nDofs,L2Err,'r-');
grid('on');
set(gca,'XScale','log','YScale','log');
set(h,'FontSize',14);
xlabel('Dofs [log]');
ylabel('Discretization error [log]');
    
p = polyfit(log(nDofs),log(L2Err),1);
add_Slope(gca,'NorthEast',p(1));
  
% Clear memory
clear all;

